hdu-2389.rain on your parade(二分匹配HK算法)

时间:2023-12-24 10:40:55

Rain on your Parade

Time Limit: 6000/3000 MS (Java/Others)    Memory Limit: 655350/165535 K (Java/Others)
Total Submission(s): 6752    Accepted Submission(s): 2117

Problem Description
You’re giving a party in the garden of your villa by the sea. The party is a huge success, and everyone is here. It’s a warm, sunny evening, and a soothing wind sends fresh, salty air from the sea. The evening is progressing just as you had imagined. It could be the perfect end of a beautiful day.
But nothing ever is perfect. One of your guests works in weather forecasting. He suddenly yells, “I know that breeze! It means its going to rain heavily in just a few minutes!” Your guests all wear their best dresses and really would not like to get wet, hence they stand terrified when hearing the bad news.
You have prepared a few umbrellas which can protect a few of your guests. The umbrellas are small, and since your guests are all slightly snobbish, no guest will share an umbrella with other guests. The umbrellas are spread across your (gigantic) garden, just like your guests. To complicate matters even more, some of your guests can’t run as fast as the others.
Can you help your guests so that as many as possible find an umbrella before it starts to pour?

Given the positions and speeds of all your guests, the positions of the umbrellas, and the time until it starts to rain, find out how many of your guests can at most reach an umbrella. Two guests do not want to share an umbrella, however.

Input
The input starts with a line containing a single integer, the number of test cases.
Each test case starts with a line containing the time t in minutes until it will start to rain (1 <=t <= 5). The next line contains the number of guests m (1 <= m <= 3000), followed by m lines containing x- and y-coordinates as well as the speed si in units per minute (1 <= si <= 3000) of the guest as integers, separated by spaces. After the guests, a single line contains n (1 <= n <= 3000), the number of umbrellas, followed by n lines containing the integer coordinates of each umbrella, separated by a space.
The absolute value of all coordinates is less than 10000.
Output
For each test case, write a line containing “Scenario #i:”, where i is the number of the test case starting at 1. Then, write a single line that contains the number of guests that can at most reach an umbrella before it starts to rain. Terminate every test case with a blank line.
Sample Input
2
1
2
1 0 3
3 0 3
2
4 0
6 0
1
2
1 1 2
3 3 2
2
2 2
4 4
Sample Output
Scenario #1:
2

Scenario #2:
2

Source
Recommend
lcy   |   We have carefully selected several similar problems for you:  2393 2390 2388 2391 2386 
 /*************************************************************************
> File Name: hdu-2389.rain_on_your_parade.cpp
> Author: CruelKing
> Mail: 2016586625@qq.com
> Created Time: 2019年09月02日 星期一 21时29分16秒
本题思路:比较裸的二分匹配,但是一看n比较大,所以需要更牛皮的算法,也即HK算法其复杂度为sqrt(n) * m.
************************************************************************/ #include <cstdio>
#include <cmath>
#include <cstring>
#include <vector>
#include <queue>
#include <map>
using namespace std; typedef long long ll;
const int maxn = + , inf = 0x3f3f3f3f;
int speed[maxn];
bool used[maxn];
int n, m, t;
typedef pair<int, int> pii;
pii umbrellas[maxn], guests[maxn];
int mx[maxn], my[maxn];
int dx[maxn], dy[maxn];
vector <int> G[maxn];
int dis; bool searchp() {
queue<int> que;
dis = inf;
memset(dx, -, sizeof dx);
memset(dy, -, sizeof dy);
for(int i = ; i <= m; i ++) {
if(mx[i] == -) {
que.push(i);
dx[i] = ;
}
}
while(!que.empty()) {
int u = que.front();
que.pop();
if(dx[u] > dis) break;
int sz = G[u].size();
for(int i = ; i < sz; i ++) {
int v = G[u][i];
if(dy[v] == -) {
dy[v] = dx[u] + ;
if(my[v] == -) dis = dy[v];
else {
dx[my[v]] = dy[v] + ;
que.push(my[v]);
}
}
}
}
return dis != inf;
} bool dfs(int u) {
int sz = G[u].size();
for(int i = ; i < sz;i ++) {
int v = G[u][i];
if(!used[v] && dy[v] == dx[u] + ) {
used[v] = true;
if(my[v] != - && dy[v] == dis) continue;
if(my[v] == - || dfs(my[v])) {
my[v] = u;
mx[u] = v;
return true;
}
}
}
return false;
} int maxmatch() {
int res = ;
memset(mx, -, sizeof mx);
memset(my, -, sizeof my);
while(searchp()) {
memset(used, false, sizeof used);
for(int i = ; i <= m;i ++) {
if(mx[i] == - && dfs(i)) res ++;
}
}
return res;
} bool has_distance(int i, int j) {
ll temp = (umbrellas[i].first - guests[j].first) * (umbrellas[i].first - guests[j].first) + (umbrellas[i].second - guests[j].second) * (umbrellas[i].second - guests[j].second);
return temp <= (ll)speed[j] * speed[j] * t * t;
} int main() {
int T, Case = ;
scanf("%d", &T);
while(T --) {
scanf("%d", &t);
scanf("%d", &m);
for(int i = ; i <= m; i ++) {
scanf("%d %d %d", &guests[i].first, &guests[i].second, &speed[i]);
}
scanf("%d", &n);
for(int i = ; i <= n; i ++) {
scanf("%d %d", &umbrellas[i].first, &umbrellas[i].second);
for(int j = ; j <= m; j ++) {
if(has_distance(i, j)) G[j].push_back(i);
}
}
int res = maxmatch();
for(int i = ; i <= m; i ++) G[i].clear();
printf("Scenario #%d:\n", ++Case);
printf("%d\n\n", res);
}
return ;
}